import math

class Cercle:
    
    def __init__(self, rayon, centre):
        
        self.rayon = rayon
        self.x, self.y = centre
        
    @property
    def aire(self):
        return math.pi * self.rayon * self.rayon
    
    def intersect(self, autre_cercle):
        # calculer la distance entre les deux cercle
        dx = self.x - autre_cercle.x
        dy = self.y - autre_cercle.y
        print("distance en x : %s" % dx)
        print("distance en y : %s" % dy)
        D = math.sqrt(dx**2 + dy**2)
        print("distance en 2D : %s" % D)
        
        print("somme des rayons = %s" % (self.rayon + autre_cercle.rayon))
        # renvoyer True ou False
        # suivant si D < (somme des rayons)
        return D < (self.rayon + autre_cercle.rayon)

class Cylindre(Cercle):
    
    def __init__(self, rayon, centre, hauteur):
        super().__init__(rayon, (centre[0], centre[1]))
        self.z = centre[2]
        self.hauteur = hauteur
        
    def intersect(self, autre_cylindre):
        
        # est-ce que ça s'intersecte en 2D?
        # -> appeler la methode parente ?
        if not super().intersect(autre_cylindre):
            return False
        print("ca se touche en 2D")
        
        # + est-ce que ça s'intersecte en z ?
        dz = self.z - autre_cylindre.z
        somme_demi_hauteurs = (self.hauteur + autre_cylindre.hauteur)/2
        print("dz = %s" % dz)
        print("somme des demi hauteurs = %s" % somme_demi_hauteurs)
        return abs(dz) < somme_demi_hauteurs
        
        
####################
    
c1 = Cercle(5, (-3, 2))
c2 = Cercle(4, (0, 1))
print(c1)
print(c2)
print(c1.intersect(c2))
print(c2.intersect(c1))

    
c3 = Cylindre(5, (-3, 2, 4), 1)
c4 = Cylindre(4, (0, 1, 3), 3)
print(c3)
print(c4)
print(c3.intersect(c4))
print(c4.intersect(c3))
